testautomation_surface.c File Reference
`#include <stdio.h>`
`#include <unistd.h>`
`#include <sys/stat.h>`
`#include "SDL.h"`
`#include "SDL_test.h"`
Include dependency graph for testautomation_surface.c:

Go to the source code of this file.

## Macros

#define | _CRT_SECURE_NO_DEPRECATE
#define | _CRT_NONSTDC_NO_DEPRECATE
#define | TEST_SURFACE_WIDTH testSurface->w
#define | TEST_SURFACE_HEIGHT testSurface->h

## Functions

void | _surfaceSetUp (void *arg)
void | _surfaceTearDown (void *arg)
void | _clearTestSurface ()
void | _testBlitBlendMode (int mode)
void | _AssertFileExist (const char *filename)
int | surface_testSaveLoadBitmap (void *arg)
| Tests sprite saving and loading. More...
int | surface_testSurfaceConversion (void *arg)
int | surface_testCompleteSurfaceConversion (void *arg)
int | surface_testLoadFailure (void *arg)
| Tests sprite loading. A failure case. More...
int | surface_testBlit (void *arg)
| Tests some blitting routines. More...
int | surface_testBlitColorMod (void *arg)
| Tests some blitting routines with color mod. More...
int | surface_testBlitAlphaMod (void *arg)
| Tests some blitting routines with alpha mod. More...
int | surface_testBlitBlendNone (void *arg)
| Tests some more blitting routines. More...
int | surface_testBlitBlendBlend (void *arg)
| Tests some more blitting routines. More...
int | surface_testBlitBlendAdd (void *arg)
| Tests some more blitting routines. More...
int | surface_testBlitBlendMod (void *arg)
| Tests some more blitting routines. More...
int | surface_testBlitBlendLoop (void *arg)
| Tests some more blitting routines with loop. More...

## Variables

static SDL_Surface * | referenceSurface = NULL
static SDL_Surface * | testSurface = NULL
static const SDLTest_TestCaseReference | surfaceTest1
static const SDLTest_TestCaseReference | surfaceTest2
static const SDLTest_TestCaseReference | surfaceTest3
static const SDLTest_TestCaseReference | surfaceTest4
static const SDLTest_TestCaseReference | surfaceTest5
static const SDLTest_TestCaseReference | surfaceTest6
static const SDLTest_TestCaseReference | surfaceTest7
static const SDLTest_TestCaseReference | surfaceTest8
static const SDLTest_TestCaseReference | surfaceTest9
static const SDLTest_TestCaseReference | surfaceTest10
static const SDLTest_TestCaseReference | surfaceTest11
static const SDLTest_TestCaseReference | surfaceTest12
static const SDLTest_TestCaseReference * | surfaceTests []
SDLTest_TestSuiteReference | surfaceTestSuite

## Macro Definition Documentation

## _CRT_NONSTDC_NO_DEPRECATE

#define _CRT_NONSTDC_NO_DEPRECATE

Definition at line 8 of file testautomation_surface.c.

## _CRT_SECURE_NO_DEPRECATE

#define _CRT_SECURE_NO_DEPRECATE

Original code: automated SDL surface test written by Edgar Simo "bobbens" Adapted/rewritten for test lib by Andreas Schiffler

Definition at line 7 of file testautomation_surface.c.

## TEST_SURFACE_HEIGHT

#define TEST_SURFACE_HEIGHT testSurface->h

Definition at line 33 of file testautomation_surface.c.

## TEST_SURFACE_WIDTH

#define TEST_SURFACE_WIDTH testSurface->w

Definition at line 32 of file testautomation_surface.c.

## Function Documentation

## _AssertFileExist()

void _AssertFileExist | ( | const char * | filename | ) |

Definition at line 205 of file testautomation_surface.c.

References SDLTest_AssertCheck().

Referenced by surface_testSaveLoadBitmap().

{
struct stat st;
int ret = stat(filename, &st);
SDLTest_AssertCheck(ret == 0, "Verify file '%s' exists", filename);
}
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
sort_controllers.filename
string filename
Definition: sort_controllers.py:8

## _clearTestSurface()

void _clearTestSurface | ( |  | ) |

Helper that clears the test surface

Definition at line 82 of file testautomation_surface.c.

References SDL_Surface::format, NULL, SDL_FillRect, SDL_MapRGBA, SDLTest_AssertCheck(), and SDLTest_AssertPass().

Referenced by _testBlitBlendMode().

{
int ret;
Uint32 color;
/* Clear surface. */
color = SDL_MapRGBA( testSurface->format, 0, 0, 0, 0);
SDLTest_AssertPass("Call to SDL_MapRGBA()");
ret = SDL_FillRect( testSurface, NULL, color);
SDLTest_AssertPass("Call to SDL_FillRect()");
SDLTest_AssertCheck(ret == 0, "Verify result from SDL_FillRect, expected: 0, got: %i", ret);
}
SDL_MapRGBA
#define SDL_MapRGBA
Definition: SDL_dynapi_overrides.h:287
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
Uint32
uint32_t Uint32
Definition: SDL_stdinc.h:181
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
NULL
#define NULL
Definition: begin_code.h:164
SDL_Surface::format
SDL_PixelFormat * format
Definition: SDL_surface.h:72
testSurface
static SDL_Surface * testSurface
Definition: testautomation_surface.c:28
SDL_FillRect
#define SDL_FillRect
Definition: SDL_dynapi_overrides.h:466
color
GLuint color
Definition: SDL_opengl_glext.h:1148

## _surfaceSetUp()

void _surfaceSetUp | ( | void * | arg | ) |

Definition at line 39 of file testautomation_surface.c.

References blendMode, SDL_Surface::h, NULL, SDL_BLENDMODE_NONE, SDL_CreateRGBSurface, SDL_GetSurfaceBlendMode, SDL_SetSurfaceBlendMode, SDL_SWSURFACE, SDLTest_AssertCheck(), SDLTest_ImageBlit(), and SDL_Surface::w.

{
int result;
SDL_BlendMode blendMode = SDL_BLENDMODE_NONE;
SDL_BlendMode currentBlendMode;
Uint32 rmask, gmask, bmask, amask;
#if SDL_BYTEORDER == SDL_BIG_ENDIAN
rmask = 0xff000000;
gmask = 0x00ff0000;
bmask = 0x0000ff00;
amask = 0x000000ff;
#else
rmask = 0x000000ff;
gmask = 0x0000ff00;
bmask = 0x00ff0000;
amask = 0xff000000;
#endif
referenceSurface = SDLTest_ImageBlit(); /* For size info */
testSurface = SDL_CreateRGBSurface(SDL_SWSURFACE, referenceSurface->w, referenceSurface->h, 32, rmask, gmask, bmask, amask);
SDLTest_AssertCheck(testSurface != NULL, "Check that testSurface is not NULL");
if (testSurface != NULL) {
/* Disable blend mode for target surface */
result = SDL_SetSurfaceBlendMode(testSurface, blendMode);
SDLTest_AssertCheck(result == 0, "Validate result from SDL_SetSurfaceBlendMode, expected: 0, got: %i", result);
result = SDL_GetSurfaceBlendMode(testSurface, &currentBlendMode);
SDLTest_AssertCheck(result == 0, "Validate result from SDL_GetSurfaceBlendMode, expected: 0, got: %i", result);
SDLTest_AssertCheck(currentBlendMode == blendMode, "Validate blendMode, expected: %i, got: %i", blendMode, currentBlendMode);
}
}
result
GLuint64EXT * result
Definition: SDL_opengl_glext.h:9432
SDL_Surface::h
int h
Definition: SDL_surface.h:73
SDL_BLENDMODE_NONE
Definition: SDL_blendmode.h:42
SDL_SWSURFACE
#define SDL_SWSURFACE
Definition: SDL_surface.h:52
SDL_BlendMode
SDL_BlendMode
The blend mode used in SDL_RenderCopy() and drawing operations.
Definition: SDL_blendmode.h:40
Uint32
uint32_t Uint32
Definition: SDL_stdinc.h:181
SDL_Surface::w
int w
Definition: SDL_surface.h:73
SDL_GetSurfaceBlendMode
#define SDL_GetSurfaceBlendMode
Definition: SDL_dynapi_overrides.h:460
blendMode
static SDL_BlendMode blendMode
Definition: testdraw2.c:34
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
NULL
#define NULL
Definition: begin_code.h:164
SDLTest_ImageBlit
SDL_Surface * SDLTest_ImageBlit(void)
Returns the Blit test image as SDL_Surface.
Definition: SDL_test_imageBlit.c:541
SDL_CreateRGBSurface
#define SDL_CreateRGBSurface
Definition: SDL_dynapi_overrides.h:444
SDL_SetSurfaceBlendMode
#define SDL_SetSurfaceBlendMode
Definition: SDL_dynapi_overrides.h:459
testSurface
static SDL_Surface * testSurface
Definition: testautomation_surface.c:28
referenceSurface
static SDL_Surface * referenceSurface
Definition: testautomation_surface.c:27

## _surfaceTearDown()

void _surfaceTearDown | ( | void * | arg | ) |

Definition at line 71 of file testautomation_surface.c.

References NULL, and SDL_FreeSurface.

{
SDL_FreeSurface(referenceSurface);
referenceSurface = NULL;
SDL_FreeSurface(testSurface);
testSurface = NULL;
}
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
NULL
#define NULL
Definition: begin_code.h:164
testSurface
static SDL_Surface * testSurface
Definition: testautomation_surface.c:28
referenceSurface
static SDL_Surface * referenceSurface
Definition: testautomation_surface.c:27

## _testBlitBlendMode()

void _testBlitBlendMode | ( | int | mode | ) |

Helper that blits in a specific blend mode, -1 for basic blitting, -2 for color mod, -3 for alpha mod, -4 for mixed blend modes.

Definition at line 98 of file testautomation_surface.c.

References _clearTestSurface(), SDL_Rect::h, SDL_Surface::h, i, j, NULL, rect, SDL_BLENDMODE_ADD, SDL_BLENDMODE_BLEND, SDL_BLENDMODE_MOD, SDL_BLENDMODE_NONE, SDL_BlitSurface, SDL_FALSE, SDL_FreeSurface, SDL_SetColorKey, SDL_SetSurfaceAlphaMod, SDL_SetSurfaceBlendMode, SDL_SetSurfaceColorMod, SDLTest_AssertCheck(), SDLTest_AssertPass(), SDLTest_ImageFace(), SDL_Rect::w, SDL_Surface::w, SDL_Rect::x, and SDL_Rect::y.

Referenced by surface_testBlit(), surface_testBlitAlphaMod(), surface_testBlitBlendAdd(), surface_testBlitBlendBlend(), surface_testBlitBlendLoop(), surface_testBlitBlendMod(), surface_testBlitBlendNone(), and surface_testBlitColorMod().

{
int ret;
int i, j, ni, nj;
SDL_Surface *face;
SDL_Rect rect;
int nmode;
SDL_BlendMode bmode;
int checkFailCount1;
int checkFailCount2;
int checkFailCount3;
int checkFailCount4;
/* Check test surface */
SDLTest_AssertCheck(testSurface != NULL, "Verify testSurface is not NULL");
if (testSurface == NULL) return;
/* Create sample surface */
face = SDLTest_ImageFace();
SDLTest_AssertCheck(face != NULL, "Verify face surface is not NULL");
if (face == NULL) return;
/* Reset alpha modulation */
ret = SDL_SetSurfaceAlphaMod(face, 255);
SDLTest_AssertPass("Call to SDL_SetSurfaceAlphaMod()");
SDLTest_AssertCheck(ret == 0, "Verify result from SDL_SetSurfaceAlphaMod(), expected: 0, got: %i", ret);
/* Reset color modulation */
ret = SDL_SetSurfaceColorMod(face, 255, 255, 255);
SDLTest_AssertPass("Call to SDL_SetSurfaceColorMod()");
SDLTest_AssertCheck(ret == 0, "Verify result from SDL_SetSurfaceColorMod(), expected: 0, got: %i", ret);
/* Reset color key */
ret = SDL_SetColorKey(face, SDL_FALSE, 0);
SDLTest_AssertPass("Call to SDL_SetColorKey()");
SDLTest_AssertCheck(ret == 0, "Verify result from SDL_SetColorKey(), expected: 0, got: %i", ret);
/* Clear the test surface */
_clearTestSurface();
/* Target rect size */
rect.w = face->w;
rect.h = face->h;
/* Steps to take */
ni = testSurface->w - face->w;
nj = testSurface->h - face->h;
/* Optionally set blend mode. */
if (mode >= 0) {
ret = SDL_SetSurfaceBlendMode( face, (SDL_BlendMode)mode );
SDLTest_AssertPass("Call to SDL_SetSurfaceBlendMode()");
SDLTest_AssertCheck(ret == 0, "Verify result from SDL_SetSurfaceBlendMode(..., %i), expected: 0, got: %i", mode, ret);
}
/* Test blend mode. */
checkFailCount1 = 0;
checkFailCount2 = 0;
checkFailCount3 = 0;
checkFailCount4 = 0;
for (j=0; j <= nj; j+=4) {
for (i=0; i <= ni; i+=4) {
if (mode == -2) {
/* Set color mod. */
ret = SDL_SetSurfaceColorMod( face, (255/nj)*j, (255/ni)*i, (255/nj)*j );
if (ret != 0) checkFailCount2++;
}
else if (mode == -3) {
/* Set alpha mod. */
ret = SDL_SetSurfaceAlphaMod( face, (255/ni)*i );
if (ret != 0) checkFailCount3++;
}
else if (mode == -4) {
/* Crazy blending mode magic. */
nmode = (i/4*j/4) % 4;
if (nmode==0) {
bmode = SDL_BLENDMODE_NONE;
} else if (nmode==1) {
bmode = SDL_BLENDMODE_BLEND;
} else if (nmode==2) {
bmode = SDL_BLENDMODE_ADD;
} else if (nmode==3) {
bmode = SDL_BLENDMODE_MOD;
}
ret = SDL_SetSurfaceBlendMode( face, bmode );
if (ret != 0) checkFailCount4++;
}
/* Blitting. */
rect.x = i;
rect.y = j;
ret = SDL_BlitSurface( face, NULL, testSurface, &rect );
if (ret != 0) checkFailCount1++;
}
}
SDLTest_AssertCheck(checkFailCount1 == 0, "Validate results from calls to SDL_BlitSurface, expected: 0, got: %i", checkFailCount1);
SDLTest_AssertCheck(checkFailCount2 == 0, "Validate results from calls to SDL_SetSurfaceColorMod, expected: 0, got: %i", checkFailCount2);
SDLTest_AssertCheck(checkFailCount3 == 0, "Validate results from calls to SDL_SetSurfaceAlphaMod, expected: 0, got: %i", checkFailCount3);
SDLTest_AssertCheck(checkFailCount4 == 0, "Validate results from calls to SDL_SetSurfaceBlendMode, expected: 0, got: %i", checkFailCount4);
/* Clean up */
SDL_FreeSurface(face);
face = NULL;
}
_clearTestSurface
void _clearTestSurface()
Definition: testautomation_surface.c:82
SDL_Surface::h
int h
Definition: SDL_surface.h:73
SDL_BLENDMODE_NONE
Definition: SDL_blendmode.h:42
SDL_BlendMode
SDL_BlendMode
The blend mode used in SDL_RenderCopy() and drawing operations.
Definition: SDL_blendmode.h:40
rect
SDL_Rect rect
Definition: testrelative.c:27
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
SDL_FALSE
Definition: SDL_stdinc.h:141
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDL_BlitSurface
#define SDL_BlitSurface
Definition: SDL_surface.h:476
SDL_Surface::w
int w
Definition: SDL_surface.h:73
SDL_BLENDMODE_MOD
Definition: SDL_blendmode.h:50
SDLTest_ImageFace
SDL_Surface * SDLTest_ImageFace(void)
Returns the Face test image as SDL_Surface.
Definition: SDL_test_imageFace.c:224
face
GLenum GLuint GLint GLenum face
Definition: SDL_opengl_glext.h:3019
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
SDL_SetSurfaceColorMod
#define SDL_SetSurfaceColorMod
Definition: SDL_dynapi_overrides.h:455
j
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int int in j)
Definition: SDL_x11sym.h:50
mode
GLenum mode
Definition: SDL_opengl_glext.h:1122
SDL_SetColorKey
#define SDL_SetColorKey
Definition: SDL_dynapi_overrides.h:453
SDL_Rect::x
int x
Definition: SDL_rect.h:66
SDL_Rect::w
int w
Definition: SDL_rect.h:67
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
NULL
#define NULL
Definition: begin_code.h:164
SDL_Rect::h
int h
Definition: SDL_rect.h:67
SDL_SetSurfaceBlendMode
#define SDL_SetSurfaceBlendMode
Definition: SDL_dynapi_overrides.h:459
SDL_BLENDMODE_ADD
Definition: SDL_blendmode.h:47
testSurface
static SDL_Surface * testSurface
Definition: testautomation_surface.c:28
SDL_Rect::y
int y
Definition: SDL_rect.h:66
SDL_SetSurfaceAlphaMod
#define SDL_SetSurfaceAlphaMod
Definition: SDL_dynapi_overrides.h:457
SDL_Rect
A rectangle, with the origin at the upper left.
Definition: SDL_rect.h:64
SDL_BLENDMODE_BLEND
Definition: SDL_blendmode.h:44

## surface_testBlit()

int surface_testBlit | ( | void * | arg | ) |

Tests some blitting routines.

Definition at line 409 of file testautomation_surface.c.

References _testBlitBlendMode(), SDL_FreeSurface, SDLTest_AssertCheck(), SDLTest_CompareSurfaces(), SDLTest_ImageBlit(), and TEST_COMPLETED.

{
int ret;
SDL_Surface *compareSurface;
/* Basic blitting */
_testBlitBlendMode(-1);
/* Verify result by comparing surfaces */
compareSurface = SDLTest_ImageBlit();
ret = SDLTest_CompareSurfaces( testSurface, compareSurface, 0 );
SDLTest_AssertCheck(ret == 0, "Validate result from SDLTest_CompareSurfaces, expected: 0, got: %i", ret);
/* Clean up. */
SDL_FreeSurface(compareSurface);
return TEST_COMPLETED;
}
SDLTest_CompareSurfaces
int SDLTest_CompareSurfaces(SDL_Surface *surface, SDL_Surface *referenceSurface, int allowable_error)
Compares a surface and with reference image data for equality.
Definition: SDL_test_compare.c:39
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
SDLTest_ImageBlit
SDL_Surface * SDLTest_ImageBlit(void)
Returns the Blit test image as SDL_Surface.
Definition: SDL_test_imageBlit.c:541
_testBlitBlendMode
void _testBlitBlendMode(int mode)
Definition: testautomation_surface.c:98
testSurface
static SDL_Surface * testSurface
Definition: testautomation_surface.c:28

## surface_testBlitAlphaMod()

int surface_testBlitAlphaMod | ( | void * | arg | ) |

Tests some blitting routines with alpha mod.

Definition at line 455 of file testautomation_surface.c.

References _testBlitBlendMode(), SDL_FreeSurface, SDLTest_AssertCheck(), SDLTest_CompareSurfaces(), SDLTest_ImageBlitAlpha(), and TEST_COMPLETED.

{
int ret;
SDL_Surface *compareSurface;
/* Basic blitting with alpha mod */
_testBlitBlendMode(-3);
/* Verify result by comparing surfaces */
compareSurface = SDLTest_ImageBlitAlpha();
ret = SDLTest_CompareSurfaces( testSurface, compareSurface, 0 );
SDLTest_AssertCheck(ret == 0, "Validate result from SDLTest_CompareSurfaces, expected: 0, got: %i", ret);
/* Clean up. */
SDL_FreeSurface(compareSurface);
return TEST_COMPLETED;
}
SDLTest_CompareSurfaces
int SDLTest_CompareSurfaces(SDL_Surface *surface, SDL_Surface *referenceSurface, int allowable_error)
Compares a surface and with reference image data for equality.
Definition: SDL_test_compare.c:39
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDLTest_ImageBlitAlpha
SDL_Surface * SDLTest_ImageBlitAlpha(void)
Returns the BlitAlpha test image as SDL_Surface.
Definition: SDL_test_imageBlit.c:1536
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
_testBlitBlendMode
void _testBlitBlendMode(int mode)
Definition: testautomation_surface.c:98
testSurface
static SDL_Surface * testSurface
Definition: testautomation_surface.c:28

## surface_testBlitBlendAdd()

int surface_testBlitBlendAdd | ( | void * | arg | ) |

Tests some more blitting routines.

Definition at line 525 of file testautomation_surface.c.

References _testBlitBlendMode(), SDL_BLENDMODE_ADD, SDL_FreeSurface, SDLTest_AssertCheck(), SDLTest_CompareSurfaces(), SDLTest_ImageBlitBlendAdd(), and TEST_COMPLETED.

{
int ret;
SDL_Surface *compareSurface;
/* Add blitting */
_testBlitBlendMode(SDL_BLENDMODE_ADD);
/* Verify result by comparing surfaces */
compareSurface = SDLTest_ImageBlitBlendAdd();
ret = SDLTest_CompareSurfaces( testSurface, compareSurface, 0 );
SDLTest_AssertCheck(ret == 0, "Validate result from SDLTest_CompareSurfaces, expected: 0, got: %i", ret);
/* Clean up. */
SDL_FreeSurface(compareSurface);
return TEST_COMPLETED;
}
SDLTest_CompareSurfaces
int SDLTest_CompareSurfaces(SDL_Surface *surface, SDL_Surface *referenceSurface, int allowable_error)
Compares a surface and with reference image data for equality.
Definition: SDL_test_compare.c:39
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDLTest_ImageBlitBlendAdd
SDL_Surface * SDLTest_ImageBlitBlendAdd(void)
Returns the BlitBlendAdd test image as SDL_Surface.
Definition: SDL_test_imageBlitBlend.c:581
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
SDL_BLENDMODE_ADD
Definition: SDL_blendmode.h:47
_testBlitBlendMode
void _testBlitBlendMode(int mode)
Definition: testautomation_surface.c:98
testSurface
static SDL_Surface * testSurface
Definition: testautomation_surface.c:28

## surface_testBlitBlendBlend()

int surface_testBlitBlendBlend | ( | void * | arg | ) |

Tests some more blitting routines.

Definition at line 502 of file testautomation_surface.c.

References _testBlitBlendMode(), SDL_BLENDMODE_BLEND, SDL_FreeSurface, SDLTest_AssertCheck(), SDLTest_CompareSurfaces(), SDLTest_ImageBlitBlend(), and TEST_COMPLETED.

{
int ret;
SDL_Surface *compareSurface;
/* Blend blitting */
_testBlitBlendMode(SDL_BLENDMODE_BLEND);
/* Verify result by comparing surfaces */
compareSurface = SDLTest_ImageBlitBlend();
ret = SDLTest_CompareSurfaces( testSurface, compareSurface, 0 );
SDLTest_AssertCheck(ret == 0, "Validate result from SDLTest_CompareSurfaces, expected: 0, got: %i", ret);
/* Clean up. */
SDL_FreeSurface(compareSurface);
return TEST_COMPLETED;
}
SDLTest_CompareSurfaces
int SDLTest_CompareSurfaces(SDL_Surface *surface, SDL_Surface *referenceSurface, int allowable_error)
Compares a surface and with reference image data for equality.
Definition: SDL_test_compare.c:39
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
_testBlitBlendMode
void _testBlitBlendMode(int mode)
Definition: testautomation_surface.c:98
testSurface
static SDL_Surface * testSurface
Definition: testautomation_surface.c:28
SDLTest_ImageBlitBlend
SDL_Surface * SDLTest_ImageBlitBlend(void)
Returns the BlitBlend test image as SDL_Surface.
Definition: SDL_test_imageBlitBlend.c:1111
SDL_BLENDMODE_BLEND
Definition: SDL_blendmode.h:44

## surface_testBlitBlendLoop()

int surface_testBlitBlendLoop | ( | void * | arg | ) |

Tests some more blitting routines with loop.

Definition at line 571 of file testautomation_surface.c.

References _testBlitBlendMode(), SDL_FreeSurface, SDLTest_AssertCheck(), SDLTest_CompareSurfaces(), SDLTest_ImageBlitBlendAll(), and TEST_COMPLETED.

{
int ret;
SDL_Surface *compareSurface;
/* All blitting modes */
_testBlitBlendMode(-4);
/* Verify result by comparing surfaces */
compareSurface = SDLTest_ImageBlitBlendAll();
ret = SDLTest_CompareSurfaces( testSurface, compareSurface, 0 );
SDLTest_AssertCheck(ret == 0, "Validate result from SDLTest_CompareSurfaces, expected: 0, got: %i", ret);
/* Clean up. */
SDL_FreeSurface(compareSurface);
return TEST_COMPLETED;
}
SDLTest_CompareSurfaces
int SDLTest_CompareSurfaces(SDL_Surface *surface, SDL_Surface *referenceSurface, int allowable_error)
Compares a surface and with reference image data for equality.
Definition: SDL_test_compare.c:39
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDLTest_ImageBlitBlendAll
SDL_Surface * SDLTest_ImageBlitBlendAll(void)
Returns the BlitBlendAll test image as SDL_Surface.
Definition: SDL_test_imageBlitBlend.c:2822
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
_testBlitBlendMode
void _testBlitBlendMode(int mode)
Definition: testautomation_surface.c:98
testSurface
static SDL_Surface * testSurface
Definition: testautomation_surface.c:28

## surface_testBlitBlendMod()

int surface_testBlitBlendMod | ( | void * | arg | ) |

Tests some more blitting routines.

Definition at line 548 of file testautomation_surface.c.

References _testBlitBlendMode(), SDL_BLENDMODE_MOD, SDL_FreeSurface, SDLTest_AssertCheck(), SDLTest_CompareSurfaces(), SDLTest_ImageBlitBlendMod(), and TEST_COMPLETED.

{
int ret;
SDL_Surface *compareSurface;
/* Mod blitting */
_testBlitBlendMode(SDL_BLENDMODE_MOD);
/* Verify result by comparing surfaces */
compareSurface = SDLTest_ImageBlitBlendMod();
ret = SDLTest_CompareSurfaces( testSurface, compareSurface, 0 );
SDLTest_AssertCheck(ret == 0, "Validate result from SDLTest_CompareSurfaces, expected: 0, got: %i", ret);
/* Clean up. */
SDL_FreeSurface(compareSurface);
return TEST_COMPLETED;
}
SDLTest_CompareSurfaces
int SDLTest_CompareSurfaces(SDL_Surface *surface, SDL_Surface *referenceSurface, int allowable_error)
Compares a surface and with reference image data for equality.
Definition: SDL_test_compare.c:39
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDL_BLENDMODE_MOD
Definition: SDL_blendmode.h:50
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
_testBlitBlendMode
void _testBlitBlendMode(int mode)
Definition: testautomation_surface.c:98
testSurface
static SDL_Surface * testSurface
Definition: testautomation_surface.c:28
SDLTest_ImageBlitBlendMod
SDL_Surface * SDLTest_ImageBlitBlendMod(void)
Returns the BlitBlendMod test image as SDL_Surface.
Definition: SDL_test_imageBlitBlend.c:1541

## surface_testBlitBlendNone()

int surface_testBlitBlendNone | ( | void * | arg | ) |

Tests some more blitting routines.

Definition at line 479 of file testautomation_surface.c.

References _testBlitBlendMode(), SDL_BLENDMODE_NONE, SDL_FreeSurface, SDLTest_AssertCheck(), SDLTest_CompareSurfaces(), SDLTest_ImageBlitBlendNone(), and TEST_COMPLETED.

{
int ret;
SDL_Surface *compareSurface;
/* Basic blitting */
_testBlitBlendMode(SDL_BLENDMODE_NONE);
/* Verify result by comparing surfaces */
compareSurface = SDLTest_ImageBlitBlendNone();
ret = SDLTest_CompareSurfaces( testSurface, compareSurface, 0 );
SDLTest_AssertCheck(ret == 0, "Validate result from SDLTest_CompareSurfaces, expected: 0, got: %i", ret);
/* Clean up. */
SDL_FreeSurface(compareSurface);
return TEST_COMPLETED;
}
SDLTest_CompareSurfaces
int SDLTest_CompareSurfaces(SDL_Surface *surface, SDL_Surface *referenceSurface, int allowable_error)
Compares a surface and with reference image data for equality.
Definition: SDL_test_compare.c:39
SDL_BLENDMODE_NONE
Definition: SDL_blendmode.h:42
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
_testBlitBlendMode
void _testBlitBlendMode(int mode)
Definition: testautomation_surface.c:98
testSurface
static SDL_Surface * testSurface
Definition: testautomation_surface.c:28
SDLTest_ImageBlitBlendNone
SDL_Surface * SDLTest_ImageBlitBlendNone(void)
Returns the BlitBlendNone test image as SDL_Surface.
Definition: SDL_test_imageBlitBlend.c:2354

## surface_testBlitColorMod()

int surface_testBlitColorMod | ( | void * | arg | ) |

Tests some blitting routines with color mod.

Definition at line 432 of file testautomation_surface.c.

References _testBlitBlendMode(), SDL_FreeSurface, SDLTest_AssertCheck(), SDLTest_CompareSurfaces(), SDLTest_ImageBlitColor(), and TEST_COMPLETED.

{
int ret;
SDL_Surface *compareSurface;
/* Basic blitting with color mod */
_testBlitBlendMode(-2);
/* Verify result by comparing surfaces */
compareSurface = SDLTest_ImageBlitColor();
ret = SDLTest_CompareSurfaces( testSurface, compareSurface, 0 );
SDLTest_AssertCheck(ret == 0, "Validate result from SDLTest_CompareSurfaces, expected: 0, got: %i", ret);
/* Clean up. */
SDL_FreeSurface(compareSurface);
return TEST_COMPLETED;
}
SDLTest_CompareSurfaces
int SDLTest_CompareSurfaces(SDL_Surface *surface, SDL_Surface *referenceSurface, int allowable_error)
Compares a surface and with reference image data for equality.
Definition: SDL_test_compare.c:39
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
_testBlitBlendMode
void _testBlitBlendMode(int mode)
Definition: testautomation_surface.c:98
testSurface
static SDL_Surface * testSurface
Definition: testautomation_surface.c:28
SDLTest_ImageBlitColor
SDL_Surface * SDLTest_ImageBlitColor(void)
Returns the BlitColor test image as SDL_Surface.
Definition: SDL_test_imageBlit.c:1024

## surface_testCompleteSurfaceConversion()

int surface_testCompleteSurfaceConversion | ( | void * | arg | ) |

Definition at line 307 of file testautomation_surface.c.

References SDL_PixelFormat::Amask, SDL_PixelFormat::BytesPerPixel, SDL_Surface::format, i, j, NULL, SDL_PixelFormat::palette, SDL_Surface::pixels, SDL_AllocFormat, SDL_arraysize, SDL_assert, SDL_ConvertSurface, SDL_FreeFormat, SDL_FreeSurface, SDL_PIXELFORMAT_ABGR1555, SDL_PIXELFORMAT_ABGR4444, SDL_PIXELFORMAT_ABGR8888, SDL_PIXELFORMAT_ARGB1555, SDL_PIXELFORMAT_ARGB2101010, SDL_PIXELFORMAT_ARGB4444, SDL_PIXELFORMAT_ARGB8888, SDL_PIXELFORMAT_BGR24, SDL_PIXELFORMAT_BGR555, SDL_PIXELFORMAT_BGR565, SDL_PIXELFORMAT_BGR888, SDL_PIXELFORMAT_BGRA4444, SDL_PIXELFORMAT_BGRA5551, SDL_PIXELFORMAT_BGRA8888, SDL_PIXELFORMAT_BGRX8888, SDL_PIXELFORMAT_INDEX8, SDL_PIXELFORMAT_RGB24, SDL_PIXELFORMAT_RGB332, SDL_PIXELFORMAT_RGB444, SDL_PIXELFORMAT_RGB555, SDL_PIXELFORMAT_RGB565, SDL_PIXELFORMAT_RGB888, SDL_PIXELFORMAT_RGBA4444, SDL_PIXELFORMAT_RGBA5551, SDL_PIXELFORMAT_RGBA8888, SDL_PIXELFORMAT_RGBX8888, SDL_RLEACCEL, SDL_SetColorKey, SDLTest_AssertCheck(), SDLTest_AssertPass(), SDLTest_CompareSurfaces(), SDLTest_ImageFace(), TEST_ABORTED, and TEST_COMPLETED.

{
Uint32 pixel_formats[] = {
SDL_PIXELFORMAT_INDEX8,
SDL_PIXELFORMAT_RGB332,
SDL_PIXELFORMAT_RGB444,
SDL_PIXELFORMAT_RGB555,
SDL_PIXELFORMAT_BGR555,
SDL_PIXELFORMAT_ARGB4444,
SDL_PIXELFORMAT_RGBA4444,
SDL_PIXELFORMAT_ABGR4444,
SDL_PIXELFORMAT_BGRA4444,
SDL_PIXELFORMAT_ARGB1555,
SDL_PIXELFORMAT_RGBA5551,
SDL_PIXELFORMAT_ABGR1555,
SDL_PIXELFORMAT_BGRA5551,
SDL_PIXELFORMAT_RGB565,
SDL_PIXELFORMAT_BGR565,
SDL_PIXELFORMAT_RGB24,
SDL_PIXELFORMAT_BGR24,
SDL_PIXELFORMAT_RGB888,
SDL_PIXELFORMAT_RGBX8888,
SDL_PIXELFORMAT_BGR888,
SDL_PIXELFORMAT_BGRX8888,
SDL_PIXELFORMAT_ARGB8888,
SDL_PIXELFORMAT_RGBA8888,
SDL_PIXELFORMAT_ABGR8888,
SDL_PIXELFORMAT_BGRA8888,
SDL_PIXELFORMAT_ARGB2101010,
};
SDL_Surface *face = NULL, *cvt1, *cvt2, *final;
SDL_PixelFormat *fmt1, *fmt2;
int i, j, ret = 0;
/* Create sample surface */
face = SDLTest_ImageFace();
SDLTest_AssertCheck(face != NULL, "Verify face surface is not NULL");
if (face == NULL)
return TEST_ABORTED;
/* Set transparent pixel as the pixel at (0,0) */
if (face->format->palette) {
ret = SDL_SetColorKey(face, SDL_RLEACCEL, *(Uint8 *) face->pixels);
SDLTest_AssertPass("Call to SDL_SetColorKey()");
SDLTest_AssertCheck(ret == 0, "Verify result from SDL_SetColorKey, expected: 0, got: %i", ret);
}
for ( i = 0; i < SDL_arraysize(pixel_formats); ++i ) {
for ( j = 0; j < SDL_arraysize(pixel_formats); ++j ) {
fmt1 = SDL_AllocFormat(pixel_formats[i]);
SDL_assert(fmt1 != NULL);
cvt1 = SDL_ConvertSurface(face, fmt1, 0);
SDL_assert(cvt1 != NULL);
fmt2 = SDL_AllocFormat(pixel_formats[j]);
SDL_assert(fmt1 != NULL);
cvt2 = SDL_ConvertSurface(cvt1, fmt2, 0);
SDL_assert(cvt2 != NULL);
if ( fmt1->BytesPerPixel == face->format->BytesPerPixel &&
fmt2->BytesPerPixel == face->format->BytesPerPixel &&
(fmt1->Amask != 0) == (face->format->Amask != 0) &&
(fmt2->Amask != 0) == (face->format->Amask != 0) ) {
final = SDL_ConvertSurface( cvt2, face->format, 0 );
SDL_assert(final != NULL);
/* Compare surface. */
ret = SDLTest_CompareSurfaces( face, final, 0 );
SDLTest_AssertCheck(ret == 0, "Validate result from SDLTest_CompareSurfaces, expected: 0, got: %i", ret);
SDL_FreeSurface(final);
}
SDL_FreeSurface(cvt1);
SDL_FreeFormat(fmt1);
SDL_FreeSurface(cvt2);
SDL_FreeFormat(fmt2);
}
}
/* Clean up. */
SDL_FreeSurface( face );
return TEST_COMPLETED;
}
SDL_PIXELFORMAT_BGRX8888
Definition: SDL_pixels.h:245
SDL_PIXELFORMAT_ARGB8888
Definition: SDL_pixels.h:248
TEST_ABORTED
#define TEST_ABORTED
Definition: SDL_test_harness.h:51
SDLTest_CompareSurfaces
int SDLTest_CompareSurfaces(SDL_Surface *surface, SDL_Surface *referenceSurface, int allowable_error)
Compares a surface and with reference image data for equality.
Definition: SDL_test_compare.c:39
SDL_PIXELFORMAT_ARGB2101010
Definition: SDL_pixels.h:260
SDL_PIXELFORMAT_BGR24
Definition: SDL_pixels.h:233
SDL_PixelFormat::BytesPerPixel
Uint8 BytesPerPixel
Definition: SDL_pixels.h:320
SDL_ConvertSurface
#define SDL_ConvertSurface
Definition: SDL_dynapi_overrides.h:463
SDL_PIXELFORMAT_RGBX8888
Definition: SDL_pixels.h:239
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDL_AllocFormat
#define SDL_AllocFormat
Definition: SDL_dynapi_overrides.h:280
SDL_PIXELFORMAT_RGBA4444
Definition: SDL_pixels.h:203
Uint32
uint32_t Uint32
Definition: SDL_stdinc.h:181
SDL_PIXELFORMAT_RGB888
Definition: SDL_pixels.h:236
SDL_PIXELFORMAT_BGR888
Definition: SDL_pixels.h:242
SDL_PIXELFORMAT_ARGB4444
Definition: SDL_pixels.h:200
SDL_PIXELFORMAT_RGB332
Definition: SDL_pixels.h:188
SDLTest_ImageFace
SDL_Surface * SDLTest_ImageFace(void)
Returns the Face test image as SDL_Surface.
Definition: SDL_test_imageFace.c:224
SDL_PIXELFORMAT_RGBA8888
Definition: SDL_pixels.h:251
SDL_PIXELFORMAT_INDEX8
Definition: SDL_pixels.h:186
face
GLenum GLuint GLint GLenum face
Definition: SDL_opengl_glext.h:3019
SDL_PIXELFORMAT_BGR555
Definition: SDL_pixels.h:197
SDL_PIXELFORMAT_ABGR8888
Definition: SDL_pixels.h:254
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_Surface::pixels
void * pixels
Definition: SDL_surface.h:75
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:157
SDL_PIXELFORMAT_ABGR4444
Definition: SDL_pixels.h:206
j
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int int in j)
Definition: SDL_x11sym.h:50
SDL_FreeFormat
#define SDL_FreeFormat
Definition: SDL_dynapi_overrides.h:281
SDL_SetColorKey
#define SDL_SetColorKey
Definition: SDL_dynapi_overrides.h:453
SDL_PIXELFORMAT_BGRA4444
Definition: SDL_pixels.h:209
SDL_PIXELFORMAT_BGRA5551
Definition: SDL_pixels.h:221
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
SDL_assert
#define SDL_assert(condition)
Definition: SDL_assert.h:169
NULL
#define NULL
Definition: begin_code.h:164
SDL_Surface::format
SDL_PixelFormat * format
Definition: SDL_surface.h:72
SDL_PIXELFORMAT_RGB565
Definition: SDL_pixels.h:224
SDL_PIXELFORMAT_RGBA5551
Definition: SDL_pixels.h:215
SDL_PIXELFORMAT_RGB444
Definition: SDL_pixels.h:191
SDL_PixelFormat
Definition: SDL_pixels.h:315
SDL_PIXELFORMAT_RGB24
Definition: SDL_pixels.h:230
SDL_arraysize
#define SDL_arraysize(array)
Definition: SDL_stdinc.h:93
SDL_PixelFormat::Amask
Uint32 Amask
Definition: SDL_pixels.h:325
SDL_PixelFormat::palette
SDL_Palette * palette
Definition: SDL_pixels.h:318
SDL_PIXELFORMAT_BGRA8888
Definition: SDL_pixels.h:257
SDL_PIXELFORMAT_ABGR1555
Definition: SDL_pixels.h:218
SDL_RLEACCEL
#define SDL_RLEACCEL
Definition: SDL_surface.h:54
SDL_PIXELFORMAT_ARGB1555
Definition: SDL_pixels.h:212
SDL_PIXELFORMAT_BGR565
Definition: SDL_pixels.h:227
SDL_PIXELFORMAT_RGB555
Definition: SDL_pixels.h:194

## surface_testLoadFailure()

int surface_testLoadFailure | ( | void * | arg | ) |

Tests sprite loading. A failure case.

Definition at line 397 of file testautomation_surface.c.

References NULL, SDL_LoadBMP, SDLTest_AssertCheck(), and TEST_COMPLETED.

{
SDL_Surface *face = SDL_LoadBMP("nonexistant.bmp");
SDLTest_AssertCheck(face == NULL, "SDL_CreateLoadBmp");
return TEST_COMPLETED;
}
SDL_LoadBMP
#define SDL_LoadBMP(file)
Definition: SDL_surface.h:200
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
face
GLenum GLuint GLint GLenum face
Definition: SDL_opengl_glext.h:3019
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
NULL
#define NULL
Definition: begin_code.h:164

## surface_testSaveLoadBitmap()

int surface_testSaveLoadBitmap | ( | void * | arg | ) |

Tests sprite saving and loading.

Definition at line 220 of file testautomation_surface.c.

References _AssertFileExist(), SDL_Surface::h, NULL, SDL_FreeSurface, SDL_LoadBMP, SDL_SaveBMP, SDLTest_AssertCheck(), SDLTest_AssertPass(), SDLTest_ImageFace(), TEST_ABORTED, TEST_COMPLETED, and SDL_Surface::w.

{
int ret;
const char *sampleFilename = "testSaveLoadBitmap.bmp";
SDL_Surface *face;
SDL_Surface *rface;
/* Create sample surface */
face = SDLTest_ImageFace();
SDLTest_AssertCheck(face != NULL, "Verify face surface is not NULL");
if (face == NULL) return TEST_ABORTED;
/* Delete test file; ignore errors */
unlink(sampleFilename);
/* Save a surface */
ret = SDL_SaveBMP(face, sampleFilename);
SDLTest_AssertPass("Call to SDL_SaveBMP()");
SDLTest_AssertCheck(ret == 0, "Verify result from SDL_SaveBMP, expected: 0, got: %i", ret);
_AssertFileExist(sampleFilename);
/* Load a surface */
rface = SDL_LoadBMP(sampleFilename);
SDLTest_AssertPass("Call to SDL_LoadBMP()");
SDLTest_AssertCheck(rface != NULL, "Verify result from SDL_LoadBMP is not NULL");
if (rface != NULL) {
SDLTest_AssertCheck(face->w == rface->w, "Verify width of loaded surface, expected: %i, got: %i", face->w, rface->w);
SDLTest_AssertCheck(face->h == rface->h, "Verify height of loaded surface, expected: %i, got: %i", face->h, rface->h);
}
/* Delete test file; ignore errors */
unlink(sampleFilename);
/* Clean up */
SDL_FreeSurface(face);
face = NULL;
SDL_FreeSurface(rface);
rface = NULL;
return TEST_COMPLETED;
}
TEST_ABORTED
#define TEST_ABORTED
Definition: SDL_test_harness.h:51
SDL_Surface::h
int h
Definition: SDL_surface.h:73
SDL_LoadBMP
#define SDL_LoadBMP(file)
Definition: SDL_surface.h:200
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDL_SaveBMP
#define SDL_SaveBMP(surface, file)
Definition: SDL_surface.h:223
SDL_Surface::w
int w
Definition: SDL_surface.h:73
SDLTest_ImageFace
SDL_Surface * SDLTest_ImageFace(void)
Returns the Face test image as SDL_Surface.
Definition: SDL_test_imageFace.c:224
face
GLenum GLuint GLint GLenum face
Definition: SDL_opengl_glext.h:3019
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
NULL
#define NULL
Definition: begin_code.h:164
_AssertFileExist
void _AssertFileExist(const char *filename)
Definition: testautomation_surface.c:205

## surface_testSurfaceConversion()

int surface_testSurfaceConversion | ( | void * | arg | ) |

Definition at line 266 of file testautomation_surface.c.

References SDL_Surface::format, NULL, SDL_ConvertSurface, SDL_FreeSurface, SDL_RLEACCEL, SDL_SetColorKey, SDLTest_AssertCheck(), SDLTest_AssertPass(), SDLTest_CompareSurfaces(), SDLTest_ImageFace(), TEST_ABORTED, and TEST_COMPLETED.

{
SDL_Surface *rface = NULL, *face = NULL;
int ret = 0;
/* Create sample surface */
face = SDLTest_ImageFace();
SDLTest_AssertCheck(face != NULL, "Verify face surface is not NULL");
if (face == NULL)
return TEST_ABORTED;
/* Set transparent pixel as the pixel at (0,0) */
if (face->format->palette) {
ret = SDL_SetColorKey(face, SDL_RLEACCEL, *(Uint8 *) face->pixels);
SDLTest_AssertPass("Call to SDL_SetColorKey()");
SDLTest_AssertCheck(ret == 0, "Verify result from SDL_SetColorKey, expected: 0, got: %i", ret);
}
/* Convert to 32 bit to compare. */
rface = SDL_ConvertSurface( face, testSurface->format, 0 );
SDLTest_AssertPass("Call to SDL_ConvertSurface()");
SDLTest_AssertCheck(rface != NULL, "Verify result from SDL_ConvertSurface is not NULL");
/* Compare surface. */
ret = SDLTest_CompareSurfaces( rface, face, 0 );
SDLTest_AssertCheck(ret == 0, "Validate result from SDLTest_CompareSurfaces, expected: 0, got: %i", ret);
/* Clean up. */
SDL_FreeSurface(face);
face = NULL;
SDL_FreeSurface(rface);
rface = NULL;
return TEST_COMPLETED;
}
TEST_ABORTED
#define TEST_ABORTED
Definition: SDL_test_harness.h:51
SDLTest_CompareSurfaces
int SDLTest_CompareSurfaces(SDL_Surface *surface, SDL_Surface *referenceSurface, int allowable_error)
Compares a surface and with reference image data for equality.
Definition: SDL_test_compare.c:39
SDL_ConvertSurface
#define SDL_ConvertSurface
Definition: SDL_dynapi_overrides.h:463
SDLTest_AssertPass
void SDLTest_AssertPass(SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(1)
Explicitly pass without checking an assertion condition. Updates assertion counter.
Definition: SDL_test_assert.c:94
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDLTest_ImageFace
SDL_Surface * SDLTest_ImageFace(void)
Returns the Face test image as SDL_Surface.
Definition: SDL_test_imageFace.c:224
face
GLenum GLuint GLint GLenum face
Definition: SDL_opengl_glext.h:3019
SDLTest_AssertCheck
int SDLTest_AssertCheck(int assertCondition, SDL_PRINTF_FORMAT_STRING const char *assertDescription,...) SDL_PRINTF_VARARG_FUNC(2)
Assert for test cases that logs but does not break execution flow on failures. Updates assertion coun...
Definition: SDL_test_assert.c:65
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:157
SDL_SetColorKey
#define SDL_SetColorKey
Definition: SDL_dynapi_overrides.h:453
TEST_COMPLETED
#define TEST_COMPLETED
Definition: SDL_test_harness.h:53
NULL
#define NULL
Definition: begin_code.h:164
SDL_Surface::format
SDL_PixelFormat * format
Definition: SDL_surface.h:72
testSurface
static SDL_Surface * testSurface
Definition: testautomation_surface.c:28
SDL_RLEACCEL
#define SDL_RLEACCEL
Definition: SDL_surface.h:54

## Variable Documentation

## referenceSurface

SDL_Surface* referenceSurface = NULL

static

Definition at line 27 of file testautomation_surface.c.

Referenced by render_testBlit(), render_testBlitAlpha(), render_testBlitBlend(), render_testBlitColor(), render_testPrimitives(), and render_testPrimitivesBlend().

## surfaceTest1

const SDLTest_TestCaseReference surfaceTest1

static

Initial value:
=
{ (SDLTest_TestCaseFp)surface_testSaveLoadBitmap, "surface_testSaveLoadBitmap", "Tests sprite saving and loading.", TEST_ENABLED}
surface_testSaveLoadBitmap
int surface_testSaveLoadBitmap(void *arg)
Tests sprite saving and loading.
Definition: testautomation_surface.c:220
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 594 of file testautomation_surface.c.

## surfaceTest10

const SDLTest_TestCaseReference surfaceTest10

static

Initial value:
=
{ (SDLTest_TestCaseFp)surface_testBlitBlendBlend, "surface_testBlitBlendBlend", "Tests blitting routines with blend blending mode.", TEST_DISABLED}
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_DISABLED
#define TEST_DISABLED
Definition: SDL_test_harness.h:48
surface_testBlitBlendBlend
int surface_testBlitBlendBlend(void *arg)
Tests some more blitting routines.
Definition: testautomation_surface.c:502

Definition at line 623 of file testautomation_surface.c.

## surfaceTest11

const SDLTest_TestCaseReference surfaceTest11

static

Initial value:
=
{ (SDLTest_TestCaseFp)surface_testBlitBlendAdd, "surface_testBlitBlendAdd", "Tests blitting routines with add blending mode.", TEST_DISABLED}
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_DISABLED
#define TEST_DISABLED
Definition: SDL_test_harness.h:48
surface_testBlitBlendAdd
int surface_testBlitBlendAdd(void *arg)
Tests some more blitting routines.
Definition: testautomation_surface.c:525

Definition at line 627 of file testautomation_surface.c.

## surfaceTest12

const SDLTest_TestCaseReference surfaceTest12

static

Initial value:
=
{ (SDLTest_TestCaseFp)surface_testBlitBlendMod, "surface_testBlitBlendMod", "Tests blitting routines with mod blending mode.", TEST_ENABLED}
surface_testBlitBlendMod
int surface_testBlitBlendMod(void *arg)
Tests some more blitting routines.
Definition: testautomation_surface.c:548
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 630 of file testautomation_surface.c.

## surfaceTest2

const SDLTest_TestCaseReference surfaceTest2

static

Initial value:
=
{ (SDLTest_TestCaseFp)surface_testBlit, "surface_testBlit", "Tests basic blitting.", TEST_ENABLED}
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
surface_testBlit
int surface_testBlit(void *arg)
Tests some blitting routines.
Definition: testautomation_surface.c:409
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 597 of file testautomation_surface.c.

## surfaceTest3

const SDLTest_TestCaseReference surfaceTest3

static

Initial value:
=
{ (SDLTest_TestCaseFp)surface_testBlitBlendNone, "surface_testBlitBlendNone", "Tests blitting routines with none blending mode.", TEST_ENABLED}
surface_testBlitBlendNone
int surface_testBlitBlendNone(void *arg)
Tests some more blitting routines.
Definition: testautomation_surface.c:479
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 600 of file testautomation_surface.c.

## surfaceTest4

const SDLTest_TestCaseReference surfaceTest4

static

Initial value:
=
{ (SDLTest_TestCaseFp)surface_testLoadFailure, "surface_testLoadFailure", "Tests sprite loading. A failure case.", TEST_ENABLED}
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47
surface_testLoadFailure
int surface_testLoadFailure(void *arg)
Tests sprite loading. A failure case.
Definition: testautomation_surface.c:397

Definition at line 603 of file testautomation_surface.c.

## surfaceTest5

const SDLTest_TestCaseReference surfaceTest5

static

Initial value:
=
{ (SDLTest_TestCaseFp)surface_testSurfaceConversion, "surface_testSurfaceConversion", "Tests surface conversion.", TEST_ENABLED}
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
surface_testSurfaceConversion
int surface_testSurfaceConversion(void *arg)
Definition: testautomation_surface.c:266
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 606 of file testautomation_surface.c.

## surfaceTest6

const SDLTest_TestCaseReference surfaceTest6

static

Initial value:
=
{ (SDLTest_TestCaseFp)surface_testCompleteSurfaceConversion, "surface_testCompleteSurfaceConversion", "Tests surface conversion across all pixel formats", TEST_ENABLED}
surface_testCompleteSurfaceConversion
int surface_testCompleteSurfaceConversion(void *arg)
Definition: testautomation_surface.c:307
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47

Definition at line 609 of file testautomation_surface.c.

## surfaceTest7

const SDLTest_TestCaseReference surfaceTest7

static

Initial value:
=
{ (SDLTest_TestCaseFp)surface_testBlitColorMod, "surface_testBlitColorMod", "Tests some blitting routines with color mod.", TEST_ENABLED}
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47
surface_testBlitColorMod
int surface_testBlitColorMod(void *arg)
Tests some blitting routines with color mod.
Definition: testautomation_surface.c:432

Definition at line 612 of file testautomation_surface.c.

## surfaceTest8

const SDLTest_TestCaseReference surfaceTest8

static

Initial value:
=
{ (SDLTest_TestCaseFp)surface_testBlitAlphaMod, "surface_testBlitAlphaMod", "Tests some blitting routines with alpha mod.", TEST_ENABLED}
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_ENABLED
#define TEST_ENABLED
Definition: SDL_test_harness.h:47
surface_testBlitAlphaMod
int surface_testBlitAlphaMod(void *arg)
Tests some blitting routines with alpha mod.
Definition: testautomation_surface.c:455

Definition at line 615 of file testautomation_surface.c.

## surfaceTest9

const SDLTest_TestCaseReference surfaceTest9

static

Initial value:
=
{ (SDLTest_TestCaseFp)surface_testBlitBlendLoop, "surface_testBlitBlendLoop", "Test blitting routines with various blending modes", TEST_DISABLED}
SDLTest_TestCaseFp
int(* SDLTest_TestCaseFp)(void *arg)
Definition: SDL_test_harness.h:67
TEST_DISABLED
#define TEST_DISABLED
Definition: SDL_test_harness.h:48
surface_testBlitBlendLoop
int surface_testBlitBlendLoop(void *arg)
Tests some more blitting routines with loop.
Definition: testautomation_surface.c:571

Definition at line 619 of file testautomation_surface.c.

## surfaceTests

const SDLTest_TestCaseReference* surfaceTests[]

static

Initial value:
= {
&surfaceTest1, &surfaceTest2, &surfaceTest3, &surfaceTest4, &surfaceTest5,
&surfaceTest6, &surfaceTest7, &surfaceTest8, &surfaceTest9, &surfaceTest10,
&surfaceTest11, &surfaceTest12, NULL
}
surfaceTest10
static const SDLTest_TestCaseReference surfaceTest10
Definition: testautomation_surface.c:623
surfaceTest8
static const SDLTest_TestCaseReference surfaceTest8
Definition: testautomation_surface.c:615
surfaceTest6
static const SDLTest_TestCaseReference surfaceTest6
Definition: testautomation_surface.c:609
surfaceTest4
static const SDLTest_TestCaseReference surfaceTest4
Definition: testautomation_surface.c:603
surfaceTest9
static const SDLTest_TestCaseReference surfaceTest9
Definition: testautomation_surface.c:619
surfaceTest2
static const SDLTest_TestCaseReference surfaceTest2
Definition: testautomation_surface.c:597
surfaceTest7
static const SDLTest_TestCaseReference surfaceTest7
Definition: testautomation_surface.c:612
NULL
#define NULL
Definition: begin_code.h:164
surfaceTest11
static const SDLTest_TestCaseReference surfaceTest11
Definition: testautomation_surface.c:627
surfaceTest12
static const SDLTest_TestCaseReference surfaceTest12
Definition: testautomation_surface.c:630
surfaceTest1
static const SDLTest_TestCaseReference surfaceTest1
Definition: testautomation_surface.c:594
surfaceTest3
static const SDLTest_TestCaseReference surfaceTest3
Definition: testautomation_surface.c:600
surfaceTest5
static const SDLTest_TestCaseReference surfaceTest5
Definition: testautomation_surface.c:606

Definition at line 634 of file testautomation_surface.c.

## surfaceTestSuite

SDLTest_TestSuiteReference surfaceTestSuite

Initial value:
= {
"Surface",
_surfaceSetUp,
surfaceTests,
_surfaceTearDown
}
surfaceTests
static const SDLTest_TestCaseReference * surfaceTests[]
Definition: testautomation_surface.c:634
_surfaceTearDown
void _surfaceTearDown(void *arg)
Definition: testautomation_surface.c:71
_surfaceSetUp
void _surfaceSetUp(void *arg)
Definition: testautomation_surface.c:39

Definition at line 641 of file testautomation_surface.c.

## testSurface

SDL_Surface* testSurface = NULL

static

Definition at line 28 of file testautomation_surface.c.

Referenced by _compare().